diff --git a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
index 31d64760f..98a3097de 100644
--- a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
@@ -3,21 +3,28 @@ package net.minecraft.client.render.entity;
 import net.minecraft.client.Minecraft;
 
 import net.minecraft.client.entity.player.LocalPlayer;
+import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.Font;
+import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.PlayerSkinParser;
+import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.blockentity.BlockEntityRenderer;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.BipedModel;
 import net.minecraft.client.render.model.PlayerModel;
 import net.minecraft.client.render.model.PlayerSlimModel;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.*;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.BlocksContainer;
 import org.lwjgl.opengl.GL11;
 
 public class PlayerRenderer extends MobRenderer<Player>
@@ -28,6 +35,8 @@ public class PlayerRenderer extends MobRenderer<Player>
     private final BipedModel modelArmorChestplate;
     private final BipedModel modelArmor;
 
+    private BlocksContainer container = null;
+
     public PlayerRenderer()
     {
         super(new PlayerModel(0.0F), 0.5F);
@@ -37,14 +46,14 @@ public class PlayerRenderer extends MobRenderer<Player>
         modelThick = new PlayerModel(0.0f);
         modelSlim = new PlayerSlimModel(0.0f);
     }
-    protected void renderSpecials(Player entity, float partialTick)
+    protected void renderSpecials(Player player, float partialTick)
     {
-        if (Minecraft.getMinecraft(this).thePlayer.getGamemode() == Gamemode.spectator && entity.getGamemode() == Gamemode.spectator){
+        if (Minecraft.getMinecraft(this).thePlayer.getGamemode() == Gamemode.spectator && player.getGamemode() == Gamemode.spectator){
             GL11.glColor4f(1f, 1f, 1f, 0.25f);
-        } else if (entity.getGamemode() == Gamemode.spectator) {
+        } else if (player.getGamemode() == Gamemode.spectator) {
             GL11.glColor4f(1f, 1f, 1f, 0.0f);
         }
-        ItemStack itemstack = entity.inventory.armorItemInSlot(3);
+        ItemStack itemstack = player.inventory.armorItemInSlot(3);
         if(itemstack != null && itemstack.getItem().id < Block.blocksList.length)
         {
             GL11.glPushMatrix();
@@ -56,36 +65,36 @@ public class PlayerRenderer extends MobRenderer<Player>
                 GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
                 GL11.glScalef(f1, -f1, f1);
             }
-            ItemModelDispatcher.getInstance().getDispatch(itemstack).renderItem(Tessellator.instance, renderDispatcher.itemRenderer, entity, itemstack);
+            ItemModelDispatcher.getInstance().getDispatch(itemstack).renderItem(Tessellator.instance, renderDispatcher.itemRenderer, player, itemstack);
             GL11.glPopMatrix();
         }
 
-        boolean renderCape = bindDownloadableTexture("https://api.betterthanadventure.net/capes?username=" + entity.username, null, null);
+        boolean renderCape = bindDownloadableTexture("https://api.betterthanadventure.net/capes?username=" + player.username, null, null);
         if (!renderCape)
         {
-            renderCape = bindDownloadableTexture(entity.capeURL, null, null);
+            renderCape = bindDownloadableTexture(player.capeURL, null, null);
         }
     	
     	if(renderCape) {
             GL11.glPushMatrix();
             GL11.glColor4f(1f, 1f, 1f, 1f);
             GL11.glTranslatef(0.0F, 0.0F, 0.125F);
-            float yawOff = entity.yBodyRotO + (entity.yBodyRot - entity.yBodyRotO) * partialTick;
+            float yawOff = player.yBodyRotO + (player.yBodyRot - player.yBodyRotO) * partialTick;
             float bodyAngle = 5;
-            if(entity.isSneaking())
+            if(player.isSneaking())
             {
                 bodyAngle += 25F;
             }
-            double _xd = entity.xdO + (entity.xd - entity.xdO) * partialTick;
-            double _yd = Math.min(entity.ydO + (entity.yd - entity.ydO) * partialTick, 0);
-            double _zd = entity.zd0 + (entity.zd - entity.zd0) * partialTick;
+            double _xd = player.xdO + (player.xd - player.xdO) * partialTick;
+            double _yd = Math.min(player.ydO + (player.yd - player.ydO) * partialTick, 0);
+            double _zd = player.zd0 + (player.zd - player.zd0) * partialTick;
             double vel = -1/(3 * Math.hypot(_xd, _zd) + 1) + 1;
             double moveAng = Math.atan2(_xd, _zd);
             double yawRad = Math.toRadians(yawOff);
             double multiplier = 1 - Math.abs((((Math.cos(yawRad) + 1) - (Math.cos(moveAng) + 1) + 2)/2) -1); // Hell code, basically measures how similar the angle you're facing is to the angle you're moving, with it returning 1 if the same angle and 0 if opposite angles
-            entity.wobbleTimer += (float) (((entity.tickCount + partialTick) - entity.lastRenderTick)/(30 - 29 * MathHelper.clamp(vel, 0, 1)));
-            entity.lastRenderTick = entity.tickCount;
-            double wobble = Math.sin(entity.wobbleTimer) * (1.5 + 4.5 * vel * multiplier);
+            player.wobbleTimer += (float) (((player.tickCount + partialTick) - player.lastRenderTick)/(30 - 29 * MathHelper.clamp(vel, 0, 1)));
+            player.lastRenderTick = player.tickCount;
+            double wobble = Math.sin(player.wobbleTimer) * (1.5 + 4.5 * vel * multiplier);
             GL11.glRotatef((float) MathHelper.clamp((MathHelper.clamp(bodyAngle + vel * 100 * multiplier, bodyAngle, 100f) + wobble) - _yd * 60, 0, 180), 1.0F, 0.0F, 0.0F);
             GL11.glRotatef(0, 0.0F, 0.0F, 1.0F);
             GL11.glRotatef(0, 0.0F, 1.0F, 0.0F);
@@ -94,14 +103,21 @@ public class PlayerRenderer extends MobRenderer<Player>
             GL11.glPopMatrix();
     	}
 
-		ItemStack itemstack1 = entity.inventory.getCurrentItem();
+		ItemStack itemstack1 = player.inventory.getCurrentItem();
 		if(itemstack1 != null) {
             GL11.glPushMatrix();
-            modelBipedMain.arm0.translateTo(0.0625F);
+            modelBipedMain.armRight.translateTo(0.0625F);
             BlockModel.setRenderBlocks(renderDispatcher.itemRenderer.renderBlocksInstance);
-            ItemModelDispatcher.getInstance().getDispatch(itemstack1).renderItemThirdPerson(Tessellator.instance, renderDispatcher.itemRenderer, entity, itemstack1, true);
+            ItemModelDispatcher.getInstance().getDispatch(itemstack1).renderItemThirdPerson(Tessellator.instance, renderDispatcher.itemRenderer, player, itemstack1, true);
             GL11.glPopMatrix();
 		}
+
+        if (player.getHeldObject() != null) {
+            float walkSpeed = player.walkAnimSpeedO + (player.walkAnimSpeed - player.walkAnimSpeedO) * partialTick;
+            float walkProgress = player.walkAnimPos - player.walkAnimSpeed * (1.0F - partialTick);
+            GL11.glTranslatef(0, MathHelper.cos(walkProgress/2 * 2/3f)/26f * walkSpeed + 0.1f, 0);
+            drawHeldObject(player, partialTick);
+        }
 	}
     public void drawFirstPersonHand(Player player, boolean isLeft)
     {
@@ -112,9 +128,9 @@ public class PlayerRenderer extends MobRenderer<Player>
         modelBipedMain.isRiding = false;
         modelBipedMain.setupAnimation(0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0625F);
         if (isLeft){
-            modelBipedMain.arm1.render(0.0625F);
+            modelBipedMain.armLeft.render(0.0625F);
         } else {
-            modelBipedMain.arm0.render(0.0625F);
+            modelBipedMain.armRight.render(0.0625F);
         }
         if (modelBipedMain instanceof PlayerModel)
         {
@@ -125,6 +141,58 @@ public class PlayerRenderer extends MobRenderer<Player>
             }
         }
     }
+
+    public void drawHeldObject(Player player, float partialTick) {
+        if (player.getHeldObject() instanceof BlockEntity.CarriedBlock) {
+            BlockEntity.CarriedBlock carriedBlock = (BlockEntity.CarriedBlock)player.getHeldObject();
+            if (container == null || container.world != player.world) {
+                container = new BlocksContainer(player.world);
+            }
+
+            Tessellator tessellator = Tessellator.instance;
+            Minecraft mc = Minecraft.getMinecraft(this);
+            TextureRegistry.blockAtlas.bind();
+            GL11.glPushMatrix();
+            Lighting.disable();
+
+            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glDisable(GL11.GL_CULL_FACE);
+            if(mc.isAmbientOcclusionEnabled()) {
+                GL11.glShadeModel(GL11.GL_SMOOTH);
+            } else {
+                GL11.glShadeModel(GL11.GL_FLAT);
+            }
+            GL11.glScalef(0.55f, -0.55f, 0.55f);
+            GL11.glTranslatef(0, -0.75f, -0.75f);
+
+            int blockX = MathHelper.floor(player.x);
+            int blockY = MathHelper.floor(player.y) + 1;
+            int blockZ = MathHelper.floor(player.z);
+
+            BlockModel.setRenderBlocks(new RenderBlocks(container));
+            tessellator.startDrawingQuads();
+            tessellator.setTranslation(-blockX -0.5, -blockY -0.5, -blockZ -0.5);
+
+            container.setLightReferenceEntity(player);
+            container.setBlock(blockX, blockY, blockZ, carriedBlock.block.id, carriedBlock.metadata, carriedBlock.entity);
+            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block).renderNoCulling(Tessellator.instance, blockX, blockY, blockZ);
+            tessellator.draw();
+            tessellator.setTranslation(0, 0, 0);
+            container.setLightReferenceEntity(null);
+            container.clear();
+
+            BlockEntityRenderer<BlockEntity> renderer = BlockEntityRenderDispatcher.instance.getRenderer(carriedBlock.entity);
+            if (renderer != null) {
+                carriedBlock.entity.worldObj = player.world;
+                renderer.doRender(tessellator, carriedBlock.entity, -0.5, -0.5, -0.5, partialTick);
+                carriedBlock.entity.worldObj = null;
+            }
+
+            Lighting.enableLight();
+            GL11.glPopMatrix();
+        }
+    }
     @Override
     protected void renderSpecials(Tessellator tessellator, Player entity, double d, double d1, double d2)
     {
@@ -231,8 +299,8 @@ public class PlayerRenderer extends MobRenderer<Player>
             {
                 bindTexture("/assets/minecraft/textures/armor/skates.png");
                 BipedModel bipedModel = modelArmorChestplate;
-                bipedModel.leg0.visible = layer == 2 || layer == 3;
-                bipedModel.leg1.visible = layer == 2 || layer == 3;
+                bipedModel.legRight.visible = layer == 2 || layer == 3;
+                bipedModel.legLeft.visible = layer == 2 || layer == 3;
                 setArmorModel(bipedModel);
                 return true;
             }
@@ -244,10 +312,10 @@ public class PlayerRenderer extends MobRenderer<Player>
                 bipedModel.head.visible = layer == 0;
                 bipedModel.hair.visible = layer == 0;
                 bipedModel.body.visible = layer == 1 || layer == 2;
-                bipedModel.arm0.visible = layer == 1;
-                bipedModel.arm1.visible = layer == 1;
-                bipedModel.leg0.visible = layer == 2 || layer == 3;
-                bipedModel.leg1.visible = layer == 2 || layer == 3;
+                bipedModel.armRight.visible = layer == 1;
+                bipedModel.armLeft.visible = layer == 1;
+                bipedModel.legRight.visible = layer == 2 || layer == 3;
+                bipedModel.legLeft.visible = layer == 2 || layer == 3;
                 setArmorModel(bipedModel);
                 return true;
             }
@@ -297,7 +365,11 @@ public class PlayerRenderer extends MobRenderer<Player>
         modelBipedMain = entity.slimModel ? modelSlim : modelThick;
 
         ItemStack itemstack = entity.inventory.getCurrentItem();
+        modelArmorChestplate.holdingLarge = modelArmor.holdingLarge = modelBipedMain.holdingLarge = entity.getHeldObject() != null;
+
         modelArmorChestplate.holdingRightHand = modelArmor.holdingRightHand = modelBipedMain.holdingRightHand = itemstack != null;
+        modelArmorChestplate.holdingRightHand = modelArmor.holdingRightHand = modelBipedMain.holdingRightHand |= entity.getHeldObject() != null;
+        modelArmorChestplate.holdingLeftHand = modelArmor.holdingLeftHand = modelBipedMain.holdingLeftHand |= entity.getHeldObject() != null;
         modelArmorChestplate.sneaking = modelArmor.sneaking = modelBipedMain.sneaking = entity.isSneaking();
         modelArmorChestplate.isRiding = modelArmor.isRiding = modelBipedMain.isRiding = entity.isPassenger();
         double d3 = y - (double)entity.heightOffset;
@@ -306,8 +378,10 @@ public class PlayerRenderer extends MobRenderer<Player>
             d3 -= 0.125D;
         }
         super.render(tessellator, entity, x, d3, z, yaw, partialTick);
+        modelArmorChestplate.holdingLarge = modelArmor.holdingLarge = modelBipedMain.holdingLarge = false;
         modelArmorChestplate.sneaking = modelArmor.sneaking = modelBipedMain.sneaking = false;
         modelArmorChestplate.holdingRightHand = modelArmor.holdingRightHand = modelBipedMain.holdingRightHand = false;
+        modelArmorChestplate.holdingLeftHand = modelArmor.holdingLeftHand = modelBipedMain.holdingLeftHand = false;
         GL11.glDisable(GL11.GL_BLEND);
     }
 
@@ -315,4 +389,10 @@ public class PlayerRenderer extends MobRenderer<Player>
     public void loadEntityTexture(Player entity) {
         bindDownloadableTexture(entity.skinURL, entity.getEntityTexture(), PlayerSkinParser.instance);
     }
+
+    @Override
+    protected float limbSway(Player entity, float partialTick)
+    {
+        return super.limbSway(entity, partialTick);
+    }
 }
diff --git a/src/main/java/net/minecraft/client/render/model/BipedModel.java b/src/main/java/net/minecraft/client/render/model/BipedModel.java
index 94b0b9fec..959de6707 100644
--- a/src/main/java/net/minecraft/client/render/model/BipedModel.java
+++ b/src/main/java/net/minecraft/client/render/model/BipedModel.java
@@ -11,14 +11,15 @@ public class BipedModel extends BaseModel
     public Cube head;
     public Cube hair;
     public Cube body;
-    public Cube arm0;
-    public Cube arm1;
-    public Cube leg0;
-    public Cube leg1;
+    public Cube armRight;
+    public Cube armLeft;
+    public Cube legRight;
+    public Cube legLeft;
     public Cube ear;
     public Cube cloak;
     public boolean holdingLeftHand;
     public boolean holdingRightHand;
+    public boolean holdingLarge = false;
     public boolean sneaking;
 
 
@@ -50,20 +51,20 @@ public class BipedModel extends BaseModel
         body = new Cube(16, 16);
         body.addBox(-4F, 0.0F, -2F, 8, 12, 4, expansion);
         body.setRotationPoint(0.0F, 0.0F + yRotOffset, 0.0F);
-        arm0 = new Cube(40, 16);
-        arm0.addBox(-3F, -2F, -2F, 4, 12, 4, expansion);
-        arm0.setRotationPoint(-5F, 2.0F + yRotOffset, 0.0F);
-        arm1 = new Cube(40, 16);
-        arm1.mirror = true;
-        arm1.addBox(-1F, -2F, -2F, 4, 12, 4, expansion);
-        arm1.setRotationPoint(5F, 2.0F + yRotOffset, 0.0F);
-        leg0 = new Cube(0, 16);
-        leg0.addBox(-2F, 0.0F, -2F, 4, 12, 4, expansion);
-        leg0.setRotationPoint(-2F, 12F + yRotOffset, 0.0F);
-        leg1 = new Cube(0, 16);
-        leg1.mirror = true;
-        leg1.addBox(-2F, 0.0F, -2F, 4, 12, 4, expansion);
-        leg1.setRotationPoint(2.0F, 12F + yRotOffset, 0.0F);
+        armRight = new Cube(40, 16);
+        armRight.addBox(-3F, -2F, -2F, 4, 12, 4, expansion);
+        armRight.setRotationPoint(-5F, 2.0F + yRotOffset, 0.0F);
+        armLeft = new Cube(40, 16);
+        armLeft.mirror = true;
+        armLeft.addBox(-1F, -2F, -2F, 4, 12, 4, expansion);
+        armLeft.setRotationPoint(5F, 2.0F + yRotOffset, 0.0F);
+        legRight = new Cube(0, 16);
+        legRight.addBox(-2F, 0.0F, -2F, 4, 12, 4, expansion);
+        legRight.setRotationPoint(-2F, 12F + yRotOffset, 0.0F);
+        legLeft = new Cube(0, 16);
+        legLeft.mirror = true;
+        legLeft.addBox(-2F, 0.0F, -2F, 4, 12, 4, expansion);
+        legLeft.setRotationPoint(2.0F, 12F + yRotOffset, 0.0F);
     }
 
     @Override
@@ -72,95 +73,100 @@ public class BipedModel extends BaseModel
         setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
         head.render(scale);
         body.render(scale);
-        arm0.render(scale);
-        arm1.render(scale);
-        leg0.render(scale);
-        leg1.render(scale);
+        armRight.render(scale);
+        armLeft.render(scale);
+        legRight.render(scale);
+        legLeft.render(scale);
         hair.render(scale);
     }
 
     @Override
     public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
     {
-        head.yRot = headYaw / 57.29578F;
-        head.xRot = headPitch / 57.29578F;
+        head.yRot = headYaw / 57.29578F; // 1 rad
+        head.xRot = headPitch / 57.29578F; // 1 rad
         hair.yRot = head.yRot;
         hair.xRot = head.xRot;
-        arm0.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 2.0F * limbYaw * 0.5F;
-        arm1.xRot = MathHelper.cos(limbSwing * 0.6662F) * 2.0F * limbYaw * 0.5F;
-        arm0.zRot = 0.0F;
-        arm1.zRot = 0.0F;
-        leg0.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
-        leg1.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
-        leg0.yRot = 0.0F;
-        leg1.yRot = 0.0F;
+        if (holdingLarge) {
+            armRight.xRot = MathHelper.cos(limbSwing/2 * 0.6662F) * 2.0F * limbYaw * 0.125F - 0.65f;
+            armLeft.xRot = MathHelper.cos(limbSwing/2 * 0.6662F) * 2.0F * limbYaw * 0.125F - 0.65f;
+        } else {
+            armRight.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 2.0F * limbYaw * 0.5F;
+            armLeft.xRot = MathHelper.cos(limbSwing * 0.6662F) * 2.0F * limbYaw * 0.5F;
+        }
+        armRight.zRot = 0.0F;
+        armLeft.zRot = 0.0F;
+        legRight.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        legLeft.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        legRight.yRot = 0.0F;
+        legLeft.yRot = 0.0F;
         if(isRiding)
         {
-            arm0.xRot += -0.6283185F;
-            arm1.xRot += -0.6283185F;
-            leg0.xRot = -1.256637F;
-            leg1.xRot = -1.256637F;
-            leg0.yRot = 0.3141593F;
-            leg1.yRot = -0.3141593F;
+            armRight.xRot += -0.6283185F; // -36 deg
+            armLeft.xRot += -0.6283185F; // -36 deg
+            legRight.xRot = -1.256637F; // -72 deg
+            legLeft.xRot = -1.256637F; // -72 deg
+            legRight.yRot = 0.3141593F; // 18 deg
+            legLeft.yRot = -0.3141593F; // -18 deg
         }
         if(holdingLeftHand)
         {
-            arm1.xRot = arm1.xRot * 0.5F - 0.3141593F;
+            armLeft.xRot = (armLeft.xRot * 0.5F) - 0.3141593F /*18 deg*/;
         }
         if(holdingRightHand)
         {
-            arm0.xRot = arm0.xRot * 0.5F - 0.3141593F;
+            armRight.xRot = (armRight.xRot * 0.5F) - 0.3141593F /*18 deg*/;
         }
-        arm0.yRot = 0.0F;
-        arm1.yRot = 0.0F;
+        armRight.yRot = 0.0F;
+        armLeft.yRot = 0.0F;
         if(onGround > -9990F)
         {
             float f6 = onGround;
             body.yRot = MathHelper.sin(MathHelper.sqrt_float(f6) * MathHelper.PI * 2.0F) * 0.2F;
-            arm0.z = MathHelper.sin(body.yRot) * 5F;
-            arm0.x = -MathHelper.cos(body.yRot) * 5F;
-            arm1.z = -MathHelper.sin(body.yRot) * 5F;
-            arm1.x = MathHelper.cos(body.yRot) * 5F;
-            arm0.yRot += body.yRot;
-            arm1.yRot += body.yRot;
-            arm1.xRot += body.yRot;
+            armRight.z = MathHelper.sin(body.yRot) * 5F;
+            armRight.x = -MathHelper.cos(body.yRot) * 5F;
+            armLeft.z = -MathHelper.sin(body.yRot) * 5F;
+            armLeft.x = MathHelper.cos(body.yRot) * 5F;
+            armRight.yRot += body.yRot;
+            armLeft.yRot += body.yRot;
+            armLeft.xRot += body.xRot;
             f6 = 1.0F - onGround;
             f6 *= f6;
             f6 *= f6;
             f6 = 1.0F - f6;
             float f7 = MathHelper.sin(f6 * MathHelper.PI);
             float f8 = MathHelper.sin(onGround * MathHelper.PI) * -(head.xRot - 0.7F) * 0.75F;
-            arm0.xRot -= (double)f7 * 1.2D + (double)f8;
-            arm0.yRot += body.yRot * 2.0F;
-            arm0.zRot = MathHelper.sin(onGround * MathHelper.PI) * -0.4F;
+            armRight.xRot -= (double)f7 * 1.2D + (double)f8;
+            armRight.yRot += body.yRot * 2.0F;
+            armRight.zRot = MathHelper.sin(onGround * MathHelper.PI) * -0.4F;
         }
         if(sneaking)
         {
             body.xRot = 0.5F;
-            leg0.xRot -= 0.0F;
-            leg1.xRot -= 0.0F;
-            arm0.xRot += 0.4F;
-            arm1.xRot += 0.4F;
-            leg0.z = 4F;
-            leg1.z = 4F;
-            leg0.y = 9F;
-            leg1.y = 9F;
+            legRight.xRot -= 0.0F;
+            legLeft.xRot -= 0.0F;
+            armRight.xRot += 0.4F;
+            armLeft.xRot += 0.4F;
+            legRight.z = 4F;
+            legLeft.z = 4F;
+            legRight.y = 9F;
+            legLeft.y = 9F;
             head.y = 1.0F;
             hair.y = 1.0F;
         } else
         {
             body.xRot = 0.0F;
-            leg0.z = 0.0F;
-            leg1.z = 0.0F;
-            leg0.y = 12F;
-            leg1.y = 12F;
+            legRight.z = 0.0F;
+            legLeft.z = 0.0F;
+            legRight.y = 12F;
+            legLeft.y = 12F;
             head.y = 0.0F;
             hair.y = 0.0F;
         }
-        arm0.zRot += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
-        arm1.zRot -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
-        arm0.xRot += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
-        arm1.xRot -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        armRight.zRot += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        armLeft.zRot -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        armRight.xRot += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        armLeft.xRot -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
     }
 
     public void renderCloak(float scale)
diff --git a/src/main/java/net/minecraft/client/render/model/PlayerModel.java b/src/main/java/net/minecraft/client/render/model/PlayerModel.java
index da3e632f2..3cdb2183e 100644
--- a/src/main/java/net/minecraft/client/render/model/PlayerModel.java
+++ b/src/main/java/net/minecraft/client/render/model/PlayerModel.java
@@ -37,12 +37,12 @@ public class PlayerModel extends BipedModel {
         bipedBodyOverlay = new Cube(16, 32, 64, 64);
         bipedBodyOverlay.addBox(-4.0F, 0.0F, -2.0F, 8, 12, 4, expansion + 0.25F, true);
         bipedBodyOverlay.setRotationPoint(0.0F, 0.0F, 0.0F);
-        this.arm1 = new Cube(32, 48, 64, 64);
-        this.arm1.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, expansion, true);
-        this.arm1.setRotationPoint(5.0F, 2.0F, 0.0F);
-        this.leg1 = new Cube(16, 48, 64, 64);
-        this.leg1.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, expansion, true);
-        this.leg1.setRotationPoint(1.9F, 12.0F, 0.0F);
+        this.armLeft = new Cube(32, 48, 64, 64);
+        this.armLeft.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, expansion, true);
+        this.armLeft.setRotationPoint(5.0F, 2.0F, 0.0F);
+        this.legLeft = new Cube(16, 48, 64, 64);
+        this.legLeft.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, expansion, true);
+        this.legLeft.setRotationPoint(1.9F, 12.0F, 0.0F);
         head = new Cube(0, 0, 64, 64);
         head.addBox(-4F, -8F, -4F, 8, 8, 8, expansion, true);
         head.setRotationPoint(0.0F, 0.0F + yRotOffset, 0.0F);
@@ -52,12 +52,12 @@ public class PlayerModel extends BipedModel {
         body = new Cube(16, 16, 64, 64);
         body.addBox(-4F, 0.0F, -2F, 8, 12, 4, expansion, true);
         body.setRotationPoint(0.0F, 0.0F + yRotOffset, 0.0F);
-        arm0 = new Cube(40, 16, 64, 64);
-        arm0.addBox(-3F, -2F, -2F, 4, 12, 4, expansion, true);
-        arm0.setRotationPoint(-5F, 2.0F + yRotOffset, 0.0F);
-        leg0 = new Cube(0, 16, 64, 64);
-        leg0.addBox(-2F, 0.0F, -2F, 4, 12, 4, expansion, true);
-        leg0.setRotationPoint(-2F, 12F + yRotOffset, 0.0F);
+        armRight = new Cube(40, 16, 64, 64);
+        armRight.addBox(-3F, -2F, -2F, 4, 12, 4, expansion, true);
+        armRight.setRotationPoint(-5F, 2.0F + yRotOffset, 0.0F);
+        legRight = new Cube(0, 16, 64, 64);
+        legRight.addBox(-2F, 0.0F, -2F, 4, 12, 4, expansion, true);
+        legRight.setRotationPoint(-2F, 12F + yRotOffset, 0.0F);
     }
 
     @Override
@@ -75,10 +75,10 @@ public class PlayerModel extends BipedModel {
     @Override
 	public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale){
         super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
-        copyTranslation(this.leg1, this.bipedLeftLegOverlay);
-        copyTranslation(this.leg0, this.bipedRightLegOverlay);
-        copyTranslation(this.arm1, this.bipedLeftArmOverlay);
-        copyTranslation(this.arm0, this.bipedRightArmOverlay);
+        copyTranslation(this.legLeft, this.bipedLeftLegOverlay);
+        copyTranslation(this.legRight, this.bipedRightLegOverlay);
+        copyTranslation(this.armLeft, this.bipedLeftArmOverlay);
+        copyTranslation(this.armRight, this.bipedRightArmOverlay);
         copyTranslation(this.body, this.bipedBodyOverlay);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/model/PlayerSlimModel.java b/src/main/java/net/minecraft/client/render/model/PlayerSlimModel.java
index 3e6238cc8..0e8645d01 100644
--- a/src/main/java/net/minecraft/client/render/model/PlayerSlimModel.java
+++ b/src/main/java/net/minecraft/client/render/model/PlayerSlimModel.java
@@ -14,12 +14,12 @@ public class PlayerSlimModel extends PlayerModel {
         bipedRightArmOverlay = new Cube(40, 32, 64, 64);
         bipedRightArmOverlay.addBox(-2.0F, -2.0F, -2.0F, 3, 12, 4, expansion + 0.25F);
         bipedRightArmOverlay.setRotationPoint(-5.0F, 2.5F, 10.0F);
-        arm1 = new Cube(32, 48, 64, 64);
-        arm1.addBox(-1.0F, -2.0F, -2.0F, 3, 12, 4, expansion);
-        arm1.setRotationPoint(5.0F, 2.5F, 0.0F);
-        arm0 = new Cube(40, 16, 64, 64);
-        arm0.addBox(-2F, -2F, -2F, 3, 12, 4, expansion);
-        arm0.setRotationPoint(-5F, 2.5F + yRotOffset, 0.0F);
+        armLeft = new Cube(32, 48, 64, 64);
+        armLeft.addBox(-1.0F, -2.0F, -2.0F, 3, 12, 4, expansion);
+        armLeft.setRotationPoint(5.0F, 2.5F, 0.0F);
+        armRight = new Cube(40, 16, 64, 64);
+        armRight.addBox(-2F, -2F, -2F, 3, 12, 4, expansion);
+        armRight.setRotationPoint(-5F, 2.5F + yRotOffset, 0.0F);
 
     }
 
diff --git a/src/main/java/net/minecraft/client/render/model/SkeletonModel.java b/src/main/java/net/minecraft/client/render/model/SkeletonModel.java
index c32dd8f07..34f3d82fb 100644
--- a/src/main/java/net/minecraft/client/render/model/SkeletonModel.java
+++ b/src/main/java/net/minecraft/client/render/model/SkeletonModel.java
@@ -10,19 +10,19 @@ public class SkeletonModel extends ZombieModel
     public SkeletonModel()
     {
         float f = 0.0F;
-        arm0 = new Cube(40, 16);
-        arm0.addBox(-1F, -2F, -1F, 2, 12, 2, f);
-        arm0.setRotationPoint(-5F, 2.0F, 0.0F);
-        arm1 = new Cube(40, 16);
-        arm1.mirror = true;
-        arm1.addBox(-1F, -2F, -1F, 2, 12, 2, f);
-        arm1.setRotationPoint(5F, 2.0F, 0.0F);
-        leg0 = new Cube(0, 16);
-        leg0.addBox(-1F, 0.0F, -1F, 2, 12, 2, f);
-        leg0.setRotationPoint(-2F, 12F, 0.0F);
-        leg1 = new Cube(0, 16);
-        leg1.mirror = true;
-        leg1.addBox(-1F, 0.0F, -1F, 2, 12, 2, f);
-        leg1.setRotationPoint(2.0F, 12F, 0.0F);
+        armRight = new Cube(40, 16);
+        armRight.addBox(-1F, -2F, -1F, 2, 12, 2, f);
+        armRight.setRotationPoint(-5F, 2.0F, 0.0F);
+        armLeft = new Cube(40, 16);
+        armLeft.mirror = true;
+        armLeft.addBox(-1F, -2F, -1F, 2, 12, 2, f);
+        armLeft.setRotationPoint(5F, 2.0F, 0.0F);
+        legRight = new Cube(0, 16);
+        legRight.addBox(-1F, 0.0F, -1F, 2, 12, 2, f);
+        legRight.setRotationPoint(-2F, 12F, 0.0F);
+        legLeft = new Cube(0, 16);
+        legLeft.mirror = true;
+        legLeft.addBox(-1F, 0.0F, -1F, 2, 12, 2, f);
+        legLeft.setRotationPoint(2.0F, 12F, 0.0F);
     }
 }
